Package org.apache.bcel.verifier.statics

# Class LocalVariableInfo

java.lang.Object
org.apache.bcel.verifier.statics.LocalVariableInfo

public class LocalVariableInfo extends Object
A utility class holding the information about the name and the type of a local variable in a given slot (== index). This information often changes in course of byte code offsets.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LocalVariableInfo()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(String name, int startPc, int length, Type type)`
  Adds some information about this local variable (slot).
  `String`
  `getName(int offset)`
  Returns the name of the local variable that uses this local variable slot at the given bytecode offset.
  `Type`
  `getType(int offset)`
  Returns the type of the local variable that uses this local variable slot at the given bytecode offset.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### LocalVariableInfo

    public LocalVariableInfo()

- ## Method Details

  - ### add

    public void add(String name, int startPc, int length, Type type) throws LocalVariableInfoInconsistentException
    Adds some information about this local variable (slot).
    Parameters:
      `name` - variable name
      `startPc` - Range in which the variable is valid.
      `length` - length of ...
      `type` - variable type
    Throws:
      `LocalVariableInfoInconsistentException` - if the new information conflicts with already gathered information.

  - ### getName

    public String getName(int offset)
    Returns the name of the local variable that uses this local variable slot at the given bytecode offset. Care for legal bytecode offsets yourself, otherwise the return value might be wrong. May return 'null' if nothing is known about the type of this local variable slot at the given bytecode offset.
    Parameters:
      `offset` - bytecode offset.
    Returns:
      the name of the local variable that uses this local variable slot at the given bytecode offset.

  - ### getType

    public Type getType(int offset)
    Returns the type of the local variable that uses this local variable slot at the given bytecode offset. Care for legal bytecode offsets yourself, otherwise the return value might be wrong. May return 'null' if nothing is known about the type of this local variable slot at the given bytecode offset.
    Parameters:
      `offset` - bytecode offset.
    Returns:
      the type of the local variable that uses this local variable slot at the given bytecode offset.